Merge branch 'master' of git://git.denx.de/u-boot-microblaze
[karo-tx-uboot.git] / dts / Makefile
1 #
2 # Copyright (c) 2011 The Chromium OS Authors.
3 #
4 # See file CREDITS for list of people who contributed to this
5 # project.
6 #
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License as
9 # published by the Free Software Foundatio; either version 2 of
10 # the License, or (at your option) any later version.
11 #
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
15 # GNU General Public License for more details.
16 #
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston,
20 # MA 02111-1307 USA
21 #
22
23 # This Makefile builds the internal U-Boot fdt if CONFIG_OF_CONTROL is
24 # enabled. See doc/README.fdt-control for more details.
25
26 include $(TOPDIR)/config.mk
27
28 LIB     = $(obj)libdts.o
29
30 $(if $(CONFIG_DEFAULT_DEVICE_TREE),,\
31 $(error Please define CONFIG_DEFAULT_DEVICE_TREE in your board header file))
32 DEVICE_TREE = $(subst ",,$(CONFIG_DEFAULT_DEVICE_TREE))
33
34 $(if $(CONFIG_ARCH_DEVICE_TREE),,\
35 $(error Your architecture does not have device tree support enabled. \
36 Please define CONFIG_ARCH_DEVICE_TREE))
37
38 # We preprocess the device tree file provide a useful define
39 DTS_CPPFLAGS := -DARCH_CPU_DTS=\"$(SRCTREE)/arch/$(ARCH)/dts/$(CONFIG_ARCH_DEVICE_TREE).dtsi\" \
40                 -DBOARD_DTS=\"$(SRCTREE)/board/$(VENDOR)/$(BOARD)/dts/$(DEVICE_TREE).dts\"
41
42 all:    $(obj).depend $(LIB)
43
44 # Use a constant name for this so we can access it from C code.
45 # objcopy doesn't seem to allow us to set the symbol name independently of
46 # the filename.
47 DT_BIN  := $(obj)dt.dtb
48
49 $(DT_BIN): $(TOPDIR)/board/$(VENDOR)/dts/$(DEVICE_TREE).dts
50         rc=$$( \
51                 cat $< | $(CPP) -P $(DTS_CPPFLAGS) - | \
52                 { { $(DTC) -R 4 -p 0x1000 -O dtb -o ${DT_BIN} - 2>&1 ; \
53                     echo $$? >&3 ; } | \
54                   grep -v '^DTC: dts->dtb  on file' ; \
55                 } 3>&1 1>&2 ) ; \
56         exit $$rc
57
58 process_lds = \
59         $(1) | sed -r -n 's/^OUTPUT_$(2)[ ("]*([^")]*).*/\1/p'
60
61 # Run the compiler and get the link script from the linker
62 GET_LDS = $(CC) $(CFLAGS) $(LDFLAGS) -Wl,--verbose 2>&1
63
64 $(obj)dt.o: $(DT_BIN)
65         # We want the output format and arch.
66         # We also hope to win a prize for ugliest Makefile / shell interaction
67         # We look in the LDSCRIPT first.
68         # Then try the linker which should give us the answer.
69         # Then check it worked.
70         oformat=`$(call process_lds,cat $(LDSCRIPT),FORMAT)` ;\
71         oarch=`$(call process_lds,cat $(LDSCRIPT),ARCH)` ;\
72         \
73         [ -z $${oformat} ] && \
74                 oformat=`$(call process_lds,$(GET_LDS),FORMAT)` ;\
75         [ -z $${oarch} ] && \
76                 oarch=`$(call process_lds,$(GET_LDS),ARCH)` ;\
77         \
78         [ -z $${oformat} ] && \
79                 echo "Cannot read OUTPUT_FORMAT from lds file $(LDSCRIPT)" && \
80                 exit 1 || true ;\
81         [ -z $${oarch} ] && \
82                 echo "Cannot read OUTPUT_ARCH from lds file $(LDSCRIPT)" && \
83                 exit 1 || true ;\
84         \
85         cd $(dir ${DT_BIN}) && \
86         $(OBJCOPY) -I binary -O $${oformat} -B $${oarch} \
87                 $(notdir ${DT_BIN}) $@
88         rm $(DT_BIN)
89
90 OBJS-$(CONFIG_OF_EMBED) := dt.o
91
92 COBJS   := $(OBJS-y)
93
94 OBJS    := $(addprefix $(obj),$(COBJS))
95
96 binary: $(DT_BIN)
97
98 $(LIB): $(OBJS) $(DTB)
99         $(call cmd_link_o_target, $(OBJS))
100
101 #########################################################################
102
103 # defines $(obj).depend target
104 include $(SRCTREE)/rules.mk
105
106 sinclude $(obj).depend
107
108 #########################################################################